



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>自定义JsonResult处理JSON序列化DateTime类型数据（Ext4.2+ASP.NET MVC 4）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">自定义JsonResult处理JSON序列化DateTime类型数据（Ext4.2+ASP.NET MVC 4）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 22:14:05 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>最近项目中前台页面使用Extjs4.2 ,在后台<a href="http://www.mikel.cn/tag/asp-net" rel="external nofollow noreferrer">ASP.NET</a>&nbsp;MVC4返回的DateTime类型的数据错返回的DateTime类型的JsonResult的结果中的值是&ldquo;\/Date(1378446180000)\/此种格式，导致页面显示时间不正确(如下图创建时间列)</strong></p>
<p><strong><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/316843/201309/24113623-7050a4de14114af3ae273890e50c8731.jpg" /></strong></p>
<p>于是通过自定义JsonResult处理了JSON序列化DateTime类型数据，将处理方法贴于此，供需要的朋友交流学习！！！！</p>
<p>创建CustomResult类，继承JsonResult，&nbsp;重写 ExecuteResult方法，代码如下：</p>
<div>
<pre class="prettyprint linenums"> public class CustomResult : JsonResult<br />
    {

        public override void ExecuteResult(ControllerContext context)<br />
        {

            if (context == null)<br />
            {<br />
                throw new ArgumentNullException("context");<br />
            }

            HttpResponseBase response = context.HttpContext.Response;<br />
            if (!string.IsNullOrEmpty(this.ContentType))<br />
            {<br />
                response.ContentType = this.ContentType;<br />
            }<br />
            else<br />
            {<br />
                response.ContentType = "application/json";<br />
            }<br />
            if (this.ContentEncoding != null)<br />
            {<br />
                response.ContentEncoding = this.ContentEncoding;<br />
            }<br />
            if (this.Data != null)<br />
            {<br />
                IsoDateTimeConverter timeFormat = new IsoDateTimeConverter();<br />
                timeFormat.DateTimeFormat = "yyyy-MM-dd HH:mm:ss";<br />
                response.Write(JsonConvert.SerializeObject(this.Data,    Newtonsoft.Json.Formatting.Indented, timeFormat));

            } 

        }

    }
</pre>
</div>
<p>　　创建BaseController类，继承Controller类，重写Json方法</p>
<div>
<pre class="prettyprint linenums"> public class BaseController : Controller<br />
    {

        protected override JsonResult Json(object data, string contentType, Encoding contentEncoding)<br />
        {

            return new CustomResult<br />
            {<br />
                Data = data,<br />
                ContentType = contentType,<br />
                ContentEncoding = contentEncoding<br />
            };

        }

    }
</pre>
</div>
<p>　　这样就OK了（对了还要解释下，在CustomResult类里用到的序列化是Newtonsoft.Json.Converters），之后针对处理返回带时间格式的 项目中XXController直接继承BaseController 就可以了<img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/316843/201309/24114919-b82a64f07cc748d6a105068fd7a9d152.jpg" /></p>
<p>处理完的表格的结果如下</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/316843/201309/24115024-e5267feb098c4af89f1d5bb06eac7d32.jpg" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390rwm9d.html">年度巨献-WPF项目开发过程中WPF小知识点汇总（原创&plus;摘抄）</a>
		</li>
						<li><a href="https://www.batexi.com/a/495g6req.html">CSS基础之居中显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93ddwn8.html">Qt容器类&mdash;&mdash;1&period; QList类、QLinkedList类和QVector类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmvd219.html">python中objects的all和get方法的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x15ne8.html">基于Jquery&plus;Ajax&plus;Json实现分页显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vx7ln8.html">&period;net 实例化对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oe4539.html">this关键字之一个有趣的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj5yrxq.html">1572&colon; &lbrack;Usaco2009 Open&rsqb;工作安排Job</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z5zpk9.html">Oracle解锁scott账号</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjxyj28.html">LeetCode算法题-Number of Lines To Write String（Java实现）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meg6rpq.html">【Nuxt】配置路由</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvj6kx8.html">mycat使用之MySQL单库分表及均分数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/9600z6j9.html">玩转Python图片处理 （OpenCV-Python ）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv02zk8.html">sparkStreaming运行yarn，提交任务报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjv2nj9.html">&OpenCurlyDoubleQuote;百度杯&rdquo;CTF比赛 九月场---123</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjvll79.html">P3211 &lbrack;HNOI2011&rsqb;XOR和路径</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjyx259.html">tiny4412SDK 1312B  启动ubuntuDsektop</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jx04jq.html">dialog里屏蔽ESC和回车</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvvmzdq.html">绝对定位多个字居中显示的css</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvneexq.html">mybatis-config&period;xml配置</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90vgz3o8.html">Powershell使用管道</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1wmxn9.html">startkde出现&dollar;DISPLAY is not set or cannot connect to the X server</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mkxxxq.html">算法导论&lpar;第三版&rpar;Exercises2&period;1&lpar;插入排序、线性查找、N位大数相加&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xmxx09.html">lucene3&period;6&period;0 经典案例 入门教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z1k059.html">HDU2206 IP的计算 【经典题】</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ov0oy9.html">画8&lowbar;hdu&lowbar;1256&lpar;图形&rpar;&period;java</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv42rxq.html">windows下体验Redis</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm6l7e9.html">Go程序GC优化经验分享</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmopn79.html">安装VMware Sphere ESXi 5&period;5</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjlxwk9.html">学习MVC框架之一</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
